#ifndef KMESSAGEBOX_H
#define KMESSAGEBOX_H

#include <QMessageBox>
#include "gui_g.h"

namespace kdk {

class KMessageBoxPrivate;

class GUI_EXPORT KMessageBox:public QMessageBox
{
    Q_OBJECT

public:
    explicit KMessageBox(QWidget *parent = nullptr);
    KMessageBox(Icon icon, const QString &title, const QString &text,
                StandardButtons buttons = NoButton, QWidget *parent = nullptr,
                Qt::WindowFlags flags = Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint);
    ~KMessageBox();

    void setCustomIcon(const QIcon&icon);

    static StandardButton information(QWidget *parent, const QString &title,
         const QString &text, StandardButtons buttons = Ok,
         StandardButton defaultButton = NoButton);
    static StandardButton question(QWidget *parent, const QString &title,
         const QString &text, StandardButtons buttons = StandardButtons(Yes | No),
         StandardButton defaultButton = NoButton);
    static StandardButton warning(QWidget *parent, const QString &title,
         const QString &text, StandardButtons buttons = Ok,
         StandardButton defaultButton = NoButton);
    static StandardButton critical(QWidget *parent, const QString &title,
         const QString &text, StandardButtons buttons = Ok,
         StandardButton defaultButton = NoButton);
    static StandardButton success(QWidget *parent, const QString &title,
         const QString &text, StandardButtons buttons = Ok,
         StandardButton defaultButton = NoButton);

private:
    Q_DECLARE_PRIVATE(KMessageBox)
    KMessageBoxPrivate* const d_ptr;
};

}


#endif // KMESSAGEBOX_H
